package CS561A1.Farris;


import java.io.*;
import java.util.*;

public class Puzzle extends AStarSearch{

	public static HashMap<AStarSearch, AStarSearch> came_from = new HashMap<AStarSearch,AStarSearch>();
	public static List<AStarSearch> closed = new ArrayList<AStarSearch>();
	public static List<AStarSearch> openset = new ArrayList<AStarSearch>();
	public static List<String> output = new ArrayList<String>();
	public static int INDEX = 0;
	
	public Puzzle(int[][] board) {
		super(board);
		
	}
	
	public static void multiArrayCopy(int[][] source,int[][] destination) {
		
		for (int a=0;a<source.length;a++)
			{
			System.arraycopy(source[a],0,destination[a],0,source[a].length);
			}
	}
	
	//If flag == 1, check to see if node is in the openset
	//If flag == 0, check to see if node is in the closed set
	public static boolean CheckContain(AStarSearch child, int flag) {
		boolean status = false;
		
		if(flag == 1) {
			for(int i=0; i<openset.size(); i++) {
				if(Arrays.deepEquals(openset.get(i).board,child.board) == true) {
					status = true;
					INDEX = i;
				}
			}
		}
		else {
			for(int i=0; i<closed.size(); i++) {
				if(Arrays.deepEquals(closed.get(i).board,child.board) == true) {
					status = true;
				}
			}
		}
		
		return status;
	}
	
	//Function looks at all possibilites of the current board position
	//and generates all children accordingly.
	public static Vector<AStarSearch> ExpandedNode(AStarSearch node, Vector<AStarSearch> children, int g_value) {
		int temp;
		int[][] temp_board = new int[3][3];
		int[][] temp_board2 = new int[3][3];
		int[][] temp_board3 = new int[3][3];
		int[][] temp_board4 = new int[3][3];
		String move = "";
		//Vector<AStarSearch> children = new Vector<AStarSearch>();
		if (node.board[0][0] == 0) {
			
			multiArrayCopy(node.board,temp_board);
			multiArrayCopy(node.board,temp_board2);
			
			//swap with number to the right
			int temp_heuristic = node.heuristicValue;
			temp = temp_board[0][1];
			temp_board[0][1] = 0;
			temp_board[0][0] = temp;
			//temp_heuristic = Heuristic1(temp_board);
			move = "Right";
			AStarSearch new_node1 = new AStarSearch(temp_board,move);
			children.add(new_node1);
			
			//swap with number below
			temp = temp_board2[1][0];
			temp_board2[1][0] = 0;
			temp_board2[0][0] = temp;
			//temp_heuristic = Heuristic1(temp_board2);
			move = "Down";
			AStarSearch new_node2 = new AStarSearch(temp_board2,move);
			children.add(new_node2);
	
		}
		else if (node.board[0][1] == 0) {
			
			multiArrayCopy(node.board,temp_board);
			multiArrayCopy(node.board,temp_board2);
			multiArrayCopy(node.board,temp_board3);
			int temp_heuristic = node.heuristicValue;
		
			//swap with number to the left	
			temp = temp_board[0][0];
			temp_board[0][0] = 0;
			temp_board[0][1] = temp;
			temp_heuristic = Heuristic1(temp_board);
			move = "Left";
			AStarSearch new_node1 = new AStarSearch(temp_board,move);
			children.add(new_node1);
					
			//swap with number to the right
			temp = temp_board2[0][2];
			temp_board2[0][2] = 0;
			temp_board2[0][1] = temp;
			temp_heuristic = Heuristic1(temp_board2);
			move = "Right";
			AStarSearch new_node2 = new AStarSearch(temp_board2,move);
			children.add(new_node2);
			
			//swap with number below
			temp = temp_board[1][1];
			temp_board3[1][1] = 0;
			temp_board3[0][1] = temp;
			temp_heuristic = Heuristic1(temp_board3);
			move = "Down";
			AStarSearch new_node3 = new AStarSearch(temp_board3,move);
			children.add(new_node3);
		}
		else if (node.board[0][2] == 0) {
			int temp_heuristic = node.heuristicValue;
			
			multiArrayCopy(node.board,temp_board);
			multiArrayCopy(node.board,temp_board2);
			
			//swap with number to the left
			temp = temp_board[0][1];
			temp_board[0][1] = 0;
			temp_board[0][2] = temp;
			temp_heuristic = Heuristic1(temp_board);
			move = "Left";
			AStarSearch new_node1 = new AStarSearch(temp_board,move);
			children.add(new_node1);
			
			//swap with number below
			temp = temp_board2[1][2];
			temp_board2[1][2] = 0;
			temp_board2[0][2] = temp;
			temp_heuristic = Heuristic1(temp_board2);
			move = "Down";
			AStarSearch new_node2 = new AStarSearch(temp_board2,move);
			children.add(new_node2);
		}
		else if (node.board[1][0] == 0) {
			int temp_heuristic = node.heuristicValue;
			
			multiArrayCopy(node.board,temp_board);
			multiArrayCopy(node.board,temp_board2);
			multiArrayCopy(node.board,temp_board3);
			
			//swap with number to the top
			temp = temp_board[0][0];
			temp_board[0][0] = 0;
			temp_board[0][1] = temp;
			temp_heuristic = Heuristic1(temp_board);
			move = "Up";
			AStarSearch new_node1 = new AStarSearch(temp_board,move);
			children.add(new_node1);
			
			//swap with number below
			temp = temp_board2[2][0];
			temp_board2[2][0] = 0;
			temp_board2[1][0] = temp;
			temp_heuristic = Heuristic1(temp_board2);
			move = "Down";
			AStarSearch new_node2 = new AStarSearch(temp_board2,move);
			children.add(new_node2);
			
			//swap with number to the right
			temp = temp_board3[1][1];
			temp_board3[1][1] = 0;
			temp_board3[1][0] = temp;
			temp_heuristic = Heuristic1(temp_board3);
			move = "Right";
			AStarSearch new_node3 = new AStarSearch(temp_board3,move);
			children.add(new_node3);
		}
		else if (node.board[1][1] == 0) {
			int temp_heuristic = node.heuristicValue;
	
			multiArrayCopy(node.board,temp_board);
			multiArrayCopy(node.board,temp_board2);
			multiArrayCopy(node.board,temp_board3);
			multiArrayCopy(node.board,temp_board4);
			
			//swap with number to the top
			temp = temp_board[0][1];
			temp_board[0][1] = 0;
			temp_board[1][1] = temp;
			temp_heuristic = Heuristic1(temp_board);
			move = "Up";
			AStarSearch new_node1 = new AStarSearch(temp_board,move);
			children.add(new_node1);
			
			//swap with number below
			temp = temp_board2[2][1];
			temp_board2[2][1] = 0;
			temp_board2[1][1] = temp;
			temp_heuristic = Heuristic1(temp_board2);
			move = "Down";
			AStarSearch new_node2 = new AStarSearch(temp_board2,move);
			children.add(new_node2);
			
			//swap with number to the right
			temp = temp_board3[1][2];
			temp_board3[1][2] = 0;
			temp_board3[1][1] = temp;
			temp_heuristic = Heuristic1(temp_board3);
			move = "Right";
			AStarSearch new_node3 = new AStarSearch(temp_board3,move);
			children.add(new_node3);
			
			//swap with number to the left
			temp = temp_board4[1][0];
			temp_board4[1][0] = 0;
			temp_board4[1][1] = temp;
			temp_heuristic = Heuristic1(temp_board4);
			move = "Left";
			AStarSearch new_node4 = new AStarSearch(temp_board4,move);
			children.add(new_node4);
		}
		else if (node.board[1][2] == 0) {
			int temp_heuristic = node.heuristicValue;
			
			multiArrayCopy(node.board,temp_board);
			multiArrayCopy(node.board,temp_board2);
			multiArrayCopy(node.board,temp_board3);
			
			//swap with number to the top
			temp = temp_board[0][2];
			temp_board[0][2] = 0;
			temp_board[1][2] = temp;
			temp_heuristic = Heuristic1(temp_board);
			move = "Up";
			AStarSearch new_node1 = new AStarSearch(temp_board,move);
			children.add(new_node1);
			
			//swap with number below
			temp = temp_board2[2][2];
			temp_board2[2][2] = 0;
			temp_board2[1][2] = temp;
			temp_heuristic = Heuristic1(temp_board2);
			move = "Down";
			AStarSearch new_node2 = new AStarSearch(temp_board2,move);
			children.add(new_node2);
			
			//swap with number to the left
			temp = temp_board3[1][1];
			temp_board3[1][1] = 0;
			temp_board3[1][2] = temp;
			temp_heuristic = Heuristic1(temp_board3);
			move = "Left";
			AStarSearch new_node3 = new AStarSearch(temp_board3,move);
			children.add(new_node3);
		}
		else if (node.board[2][0] == 0) {
			int temp_heuristic = node.heuristicValue;
			
			multiArrayCopy(node.board,temp_board);
			multiArrayCopy(node.board,temp_board2);
			multiArrayCopy(node.board,temp_board3);
			
			//swap with number to the top
			temp = temp_board[1][0];
			temp_board[1][0] = 0;
			temp_board[2][0] = temp;
			temp_heuristic = Heuristic1(temp_board);
			move = "Up";
			AStarSearch new_node1 = new AStarSearch(temp_board,move);
			children.add(new_node1);
			
			//swap with number to the right
			temp = temp_board2[2][1];
			temp_board2[2][1] = 0;
			temp_board2[2][0] = temp;
			temp_heuristic = Heuristic1(temp_board2);
			move = "Right";
			AStarSearch new_node2 = new AStarSearch(temp_board2,move);
			children.add(new_node2);
		}
		else if (node.board[2][1] == 0) {
			int temp_heuristic = node.heuristicValue;
			
			multiArrayCopy(node.board,temp_board);
			multiArrayCopy(node.board,temp_board2);
			multiArrayCopy(node.board,temp_board3);
			
			//swap with number to the top
			temp = temp_board[1][1];
			temp_board[1][1] = 0;
			temp_board[2][1] = temp;
			temp_heuristic = Heuristic1(temp_board);
			move = "Up";
			AStarSearch new_node1 = new AStarSearch(temp_board,move);
			children.add(new_node1);
			
			//swap with number right
			temp = temp_board2[2][2];
			temp_board2[2][2] = 0;
			temp_board2[2][1] = temp;
			temp_heuristic = Heuristic1(temp_board2);
			move = "Right";
			AStarSearch new_node2 = new AStarSearch(temp_board2,move);
			children.add(new_node2);
			
			//swap with number to the left
			temp = temp_board3[2][0];
			temp_board3[2][0] = 0;
			temp_board3[2][1] = temp;
			temp_heuristic = Heuristic1(temp_board3);
			move = "Left";
			AStarSearch new_node3 = new AStarSearch(temp_board3,move);
			children.add(new_node3);
		}
		else if (node.board[2][2] == 0) {
			int temp_heuristic = node.heuristicValue;
			
			multiArrayCopy(node.board,temp_board);
			multiArrayCopy(node.board,temp_board2);
			multiArrayCopy(node.board,temp_board3);
			
			//swap with number to the top
			temp = temp_board[1][2];
			temp_board[1][2] = 0;
			temp_board[2][2] = temp;
			temp_heuristic = Heuristic1(temp_board);
			move = "Up";
			AStarSearch new_node1 = new AStarSearch(temp_board,move);
			children.add(new_node1);
			
			//swap with number to the left
			temp = temp_board2[2][1];
			temp_board2[2][1] = 0;
			temp_board2[2][2] = temp;
			temp_heuristic = Heuristic1(temp_board2);
			move = "Left";
			AStarSearch new_node2 = new AStarSearch(temp_board2,move);
			children.add(new_node2);
		}
		
		return children;
		
		
	}

	//Print out the path to the Solution
	public static void Moves(AStarSearch curr_node, int num) {
		int i = num;
	
		if(came_from.get(curr_node) != null) {
			
			//System.out.println("Move Blank Tile " + came_from.get(curr_node).move);
			//System.out.println("Move Blank Tile " + curr_node.move);
			//output.add("Move Blank Tile " + came_from.get(curr_node).move);		//Used for writing to output
			output.add("Move Blank Tile " + curr_node.move);
			i += 1;
			Moves(came_from.get(curr_node),i);		//Recursively call Moves to build path
		}
		else {
			for(int j= (output.size() -1); j>=0; j--) {
				System.out.println(output.get(j));
			}
			System.out.println("Minimum Number of Moves: " + (num-1));
			output.add("Minimum Number of Moves: " + (num-1));		//Used for writing to output
		}
	}
	
	//Read Input from file
	public static int[] Read(String arg){

		int[] input = new int[9];
		try {
			Scanner scanner = new Scanner(new File(arg));
			int i = 0;
			while(scanner.hasNextInt()){
				input[i] = scanner.nextInt();
				i++;
			}
		} catch (FileNotFoundException e) {
			System.out.println("Incorrect Input File");
			System.exit(0);
		}
		return input;
		
	}
	
	//Write output to file
	public static void Write(String arg) {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(arg));

			out.write(output.get(0));
			out.newLine();
			output.remove(0);
			String end = output.get(output.size()-1);
			output.remove(output.size()-1);
			for(int j= (output.size() -1); j>=0; j--) {
				out.write(output.get(j));
				out.newLine();
			}
			out.write(end);
			out.newLine();
			out.close();
		}catch (IOException e) {
			System.out.println("Error writing output file");
			System.exit(0);
		}
	}
	
	public static void main(String[] args) {
		
		
		//Read .txt file for input
		int[] inputs = new int[9];
		int[][] start = new int[3][3];
		inputs = Read(args[1]);
		
		
		//Creates puzzle Board
		int k = 0;
		for(int i=0; i<3; i++) {
			for(int j=0; j<3; j++) {
				start[i][j] = inputs[k];
				k++;
			}
		}
		((ArrayList<AStarSearch>) closed).ensureCapacity(50);
		((ArrayList<AStarSearch>) openset).ensureCapacity(50);
		
		//Put initial State into list
		AStarSearch begin = new AStarSearch(start);
		came_from.put(begin, null);
		openset.add(begin);
		int iterations = 0;
		while(openset.isEmpty() != true){
			
			AStarSearch node = (AStarSearch) openset.get(0);	//Get the lowest score
			
			if(node.IsGoal() == true) {	  //If goal state --> we are done
				begin.move = node.move;
				System.out.println("Sequence of Tiles to be moved:");
				Moves(node,1);		//Print out the path
				output.add(0,"Sequence of Tiles to be moved:");
				Write(args[3]);		//Write path to specified file
				
				return;
			}
			
			//Remove the node from Open and add it to Closed
			openset.remove(node);
			closed.add(node);
			
			//Expand the node to get all of its children
			Vector<AStarSearch> children = new Vector<AStarSearch>();
			children = ExpandedNode(node,children,iterations);
			
			int i = 0;
			int tentative_g = 0;
			boolean tentative_is_better = false;
			while(i < children.size()){
				
				//If Node is in Closed, skip it
				int h_value = node.heuristicValue;
				if(CheckContain(children.get(i),0) == true) {
					i++;
					continue;
				}
				
				tentative_g = 1 + node.functionValue;
				
				//Check to see if child is in Open set
				if(CheckContain(children.get(i),1) == false) {
					openset.add(children.get(i));
					tentative_is_better = true;
				}
				
				//If the child is already in the open set, choose the one with the
				//lowest f_value
				else if(CheckContain(children.get(i),1) == true) {
					
					int f_value = tentative_g + Heuristic1(children.get(i).board);
					if(f_value < openset.get(INDEX).totalCost) {
						tentative_is_better = true;
						openset.remove(INDEX);
						openset.add(children.get(i));
					}
					
				}
				//Do nothing
				else {
					tentative_is_better = false;
				}
				
				if(tentative_is_better == true){
					came_from.put(children.get(i),node);
					children.get(i).functionValue = tentative_g;
					children.get(i).heuristicValue = Heuristic1(children.get(i).board);
					children.get(i).totalCost = children.get(i).functionValue + children.get(i).heuristicValue;

				}
				i++;
				
			}
			
			//Sort the openset to place the lowest f_value first
			Collections.sort(openset);
			iterations++;

		}
		//Puzzle solution could not be found
		System.out.println("Puzzle Failed");
		System.exit(0);
	}
	

}
